var Clock = Class.create();
Clock.prototype = {
	initialize:function(t) {
		this.setUTC(0);
		this.setZoneName();
		this.setFunc();
		this.refresh(t);
		this.setFormat('Y-m-d H:i:s');
	},

	refresh:function(t) {
		this.cl = new Date();
		if (t) this.cl.setTime(t);
		this.zonemin = (this.UTC) ? 0 : this.cl.getTimezoneOffset();
	},

	setUTC:function(param) {
		this.UTC = param;
	},
	setZoneName:function(str) {
		this.zonename = str;
	},

	setFormat:function(str) {
		this.fmt = str;
	},

	setLocalDays:function(str) {
		this.localDays = str;
	},

	setFunc:function() {
		this.func = $H();
		this.func.set('r',function(t) {
				var str = this.func.get('D')(t) + ', ';
				str += this.func.get('d')(t) + ' ';
				str += this.func.get('M')(t) + ' ';
				str += this.func.get('Y')(t) + ' ';
				str += this.func.get('H')(t) + ':';
				str += this.func.get('i')(t) + ':';
				str += this.func.get('s')(t) + ' ';
				str += this.func.get('O')(t);
				return str;
			}.bind(this));

		this.func.set('c',function(t) {
				var str = this.func.get('Y')(t) + '-';
				str += this.func.get('m')(t) + '-';
				str += this.func.get('d')(t) + 'T';
				str += this.func.get('H')(t) + ':';
				str += this.func.get('i')(t) + ':';
				str += this.func.get('s')(t);
				str += this.func.get('P')(t);
				return str;
			}.bind(this));

		this.func.set('O',function(t) {
				var m = Number(this.zonemin);
				var flag = 0;
				if (m > 0) flag = 1;
				m = Math.abs(m);

				var h = Math.floor(m/60);
				m -= h*60;
				h = h >= 10 ? String(h) : '0'+String(h);
				h = (flag) ? '-'+h: '+'+h;
				m = m >= 10 ? String(m) : '0'+String(m);
				return String(h)+String(m);
			}.bind(this));

		this.func.set('P',function(t) {
				var str = this.func.get('O')(t);
				return str.substr(0,3)+":"+str.substr(3,2);
			}.bind(this));

		this.func.set('T',function(t) {
				return this.zonename;
			}.bind(this));


		this.func.set('u',function(t) { return String(t.getTime()) });
		this.func.set('U',function(t) { return String(Math.floor(Number(this.func.get('u')(t)) / 1000)) }.bind(this));

		this.func.set('Y',function(t) { return String(this.UTC ? t.getUTCFullYear() : t.getFullYear()) }.bind(this));
		this.func.set('y',function(t) { return this.func.get('Y')(t).substr(-2) }.bind(this));
		this.func.set('L',function(t) {
				var val = this.func.get('Y')(t);
				return (((val % 4 == 0) && (val % 100 != 0)) || val % 400 == 0) ? 1 : 0;
			}.bind(this));

		this.func.set('n',function(t) { return String((this.UTC ? t.getUTCMonth() : t.getMonth()) + 1) }.bind(this));
		this.func.set('m',function(t) {
				var val = this.func.get('n')(t);
				return val >= 10 ? String(val) : '0'+String(val);
			}.bind(this));
		this.func.set('M',function(t) { return this.func.get('F')(t).substr(0,3) }.bind(this));
		this.func.set('F',function(t) { return ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'][Number(this.func.get('n')(t))-1] }.bind(this));
		this.func.set('t',function(t) {
				var val = this.func.get('n')(t)-1;
				val = [31,28,31,30,31,30,31,31,30,31,30,31][val] + (val == 1 ? this.func.get('L')(t) : 0);
				return String(val);
			}.bind(this));
				
		this.func.set('j',function(t) { return String(this.UTC ? t.getUTCDate() : t.getDate()) }.bind(this));
		this.func.set('d',function(t) {
				var val = this.func.get('j')(t);
				return val >= 10 ? String(val) : '0'+String(val);
			}.bind(this));
		this.func.set('w',function(t) { return String(this.UTC ? t.getUTCDay() : t.getDay()) }.bind(this));
		this.func.set('l',function(t) { return ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'][this.func.get('w')(t)] }.bind(this));
		this.func.set('J',function(t) { return (this.localDays ? this.localDays[this.func.get('w')(t)] : this.func.get('D')(t)) }.bind(this));
		this.func.set('D',function(t) { return this.func.get('l')(t).substr(0,3) }.bind(this));
		this.func.set('z',function(t) {
				var day = 0;
				var m = this.func.get('n')(t)-1;
				if (m > 0) {
					var l = [31,28,31,30,31,30,31,31,30,31,30,31];
					l = l.splice(0,m);
					l.map(function(v) { day += v });
					if (m > 1) day += this.func.get('L')(t);
				}
						
				day += Number(this.func.get('j')(t));
				return String(day);
			}.bind(this));


		this.func.set('G',function(t) { return String(this.UTC ? t.getUTCHours() : t.getHours()) }.bind(this));
		this.func.set('g',function(t) { return String(this.func.get('G')(t) % 12) }.bind(this));
		this.func.set('H',function(t) {
				var val = this.func.get('G')(t);
				return val >= 10 ? String(val) : '0'+String(val);
			}.bind(this));
		this.func.set('h',function(t) {
				var val = this.func.get('g')(t);
				return val >= 10 ? String(val) : '0'+String(val);
			}.bind(this));
		this.func.set('a',function(t) { return Math.floor(this.func.get('G')(t) / 12) ? 'pm' : 'am' }.bind(this));
		this.func.set('A',function(t) { return this.func.get('a')(t).toUpperCase() }.bind(this));

		this.func.set('i',function(t) {
				var val = (this.UTC ? t.getUTCMinutes() : t.getMinutes());
				return val >= 10 ? String(val) : '0'+String(val);
			}.bind(this));
		this.func.set('s',function(t) {
				var val = (this.UTC ? t.getUTCSeconds() : t.getSeconds());
				return val >= 10 ? String(val) : '0'+String(val);
			}.bind(this));
		this.func.set('S',function(t) {
				var val = (this.UTC ? t.getUTCMilliseconds() : t.getMilliseconds());
				return val >= 10 ? String(val) : '0'+String(val);
			}.bind(this));
	},
	get:function(fmt) {
		fmt = fmt ? fmt : this.fmt;
		var str = fmt;
		var m = '['+this.func.keys().join('')+']';
		var re = new RegExp(m,'g');
		var alist = fmt.match(re);

		str = fmt.replace(re,"\0");

		alist.map(function(v) { if (this.func.get(v)) str = str.replace("\0",this.func.get(v)(this.cl)) }.bind(this));
		return str;
	},

	getBeginDayTime:function() {
		var time = Number(this.func.get('u')(this.cl));
		time -= this.toMilliSeconds();
		return time;
	},

	// converters
	toSeconds:function(str) {
		return Math.floor(this.toMilliSeconds(str) / 1000);
	},

	toMilliSeconds:function(str) {
		if (!str) str = this.func.get('H')(this.cl)+":"+this.func.get('i')(this.cl)+":"+this.func.get('s')(this.cl)+"."+this.func.get('S')(this.cl);
		var alist = str.split(':');
		if (alist.length<3) {
			for(var i=alist.length;i!=3;i++) { alist[i] = 0; }
		}
		return (Number(alist[0])*60*60 + Number(alist[1])*60 + Number(alist[2]))*1000;
	},

	toHours: function(sec) {
		var min = Math.floor(sec/60);
		var hour = Math.floor(min/60);
		var day = Math.floor(hour/24);
		sec -= min * 60;
		min -= hour * 60;
		hour -= day * 24;
		var str = (hour < 10 ? '0' : '') + String(hour) + ":" + (min < 10 ? '0' : '') + String(min) + ":" + (sec < 10 ? '0' : '') + String(sec);
		return [str,day];
	},

	// form tool
	setTimeChanger:function(tgt) {
		Event.observe(tgt,'keydown',this.timeChanger.bindAsEventListener(this));
	},
	timeChanger:function(e) {
		var tgt = Event.element(e);
		var plusper = (e.ctrlKey) ? 60 : 1;
		var v = tgt.value ? tgt.value : tgt.innerHTML;
		if (!v) return;
		if (e.keyCode == Event.KEY_UP) {
			v = this.toHours(this.toSeconds(v)+1*plusper)[0];
		} else if (e.keyCode == Event.KEY_DOWN) {
			v = this.toHours(this.toSeconds(v)-1*plusper)[0];
		} else {
			return;
		}
		Event.stop(e);
		if (tgt.value) {
			tgt.value = v;
		} else {
			tgt.innerHTML = v;
		}
	},

	// clocking
	start: function() {
		if (this.timer) {
			this.timer.registerCallback();
		} else {
			this.timer = new PeriodicalExecuter(function(v) { this.refreshWork() }.bind(this),1);
		}
	},
	stop: function() {
		if (this.timer) this.timer.stop();
	},
	refreshWork: function() {
		this.refresh();
	}
};