var Cookies = Class.create();
Cookies.prototype = {
	str:document.cookie,
	initialize:function() {
		this.setPath();
	},
	expires: null,
	setExpires:function(sec) {
		this.expires = null;
		if (sec) {
			var dt = new Date();
			dt.setTime(dt.getTime()+sec*1000);
			var monthNameList = new Array('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
			var weekNameList = new Array('Sun','Mon','Tue','Wed','Thi','Fri','Sat');
			this.expires = weekNameList[dt.getUTCDay()]+', '+dt.getUTCDate()+'-'+monthNameList[dt.getUTCMonth()]+'-'+dt.getUTCFullYear()+' '+(dt.getUTCHours()<10 ? '0'+dt.getUTCHours() : dt.getUTCHours())+":"+(dt.getUTCMinutes()<10 ? '0'+dt.getUTCMinutes() : dt.getUTCMinutes())+":"+(dt.getUTCSeconds()<10 ? '0'+dt.getUTCSeconds() : dt.getUTCSeconds())+' GMT';
		}
	},
	path: null,
	setPath:function(path) {
		if (path) {
			this.path = path;
		} else {
			this.path = location.pathname.substr(0,location.pathname.lastIndexOf('/')+1);
		}
	},

	key: null,
	setKey:function(keyname) {
		this.key = keyname;
	},

	value:'',
	setValue:function(v) {
		if (!this.key) return;
		this.value = escape(v);
	},
	setValueFromId:function(id,tgt) {
		if (!$(id)) return;
		var value = tgt == 'value' ? $(id).value : $(id).innerHTML;
		this.setKey(id); this.setValue(value);
	},

	setArray:function(values) {
		if (!this.key) return;
		values = values.map(function(v){ return escape(v); });
		this.value = values.length ? values.join(',') : '';
	},

	getValue:function(key) {
		if (key) this.setKey(key);
		var value;
		var values = this.str;
		if (values) {
			values = values.split(/;[ ]*/);
			value = values.findAll(function(v) { return v.split('=')[0] == this.key; }.bind(this));
			if (value.length == 1) {
				value = unescape(value[0].split('=')[1]);
			} else if (value.length) {
				values = [];
				for (var i=0;i!=value.length;i++) {
					values[values.length] = unescape(value[i].split('=')[1]);
				}
				value = values;
			} else {
				value = "";
			}
		}
		return value ? value : '';
	},
	getArray:function(key) {
		var value = this.getValue(key);
		if (!value) return;
		if (typeof value != 'object') {
			return value.split(',');
		} else {
			return value.map(function(v) { return v.split(',') });
		}
	},

	write:function() {
		if (!this.key) return;
		var value = this.key+"="+this.value+";";
		if (!this.value) this.setExpires(-1);
		if (this.path) value += ' path='+this.path+';';
		if (this.expires) value += ' expires='+this.expires+';';
		document.cookie = value;
		this.str = document.cookie;
	}
}